#!/bin/sh
#
# Script to properly update menu icons for KDE menu
# 
# 
#
PREFIX=$1

if [ $PREFIX = "/var/lib/kde/menu" ]; then
  rm -f `find /usr/share/applnk -type l -name "Debian"`
else
  exit 0
fi
# set -e
 
OLDPREFIX=/usr/share/applnk
NEWPREFIX=/usr/share/applnk
# Old Method:  
#       Old method of menus was to have all the Debian menus under
#       a single "Debian" submenu off the KDE menu.  The newer style
#       attempts to place the individual Debian submenus under the proper
#       KDE submenus.  Set this option to 1 to use the old style menus.
# 
OLDMETHOD=0


if [ $OLDMETHOD = "1" ]; then
  ln -sf $PREFIX /usr/share/applnk/Debian
  exit 0
fi

# clean out old links just in case
#rm -f `find $OLDPREFIX/ -type l`
rm -f `find $NEWPREFIX/ -type l`

rm -f $NEWPREFIX/System/Debian-Help
if [ -e $PREFIX/Help ]; then
  cp -fau /etc/kde3/debian/d-help.desktop $PREFIX/Help/.directory
  ln -sf $PREFIX/Help $NEWPREFIX/System/Debian-Help
fi

rm -f $NEWPREFIX/System/Debian-Screen
if [ -e $PREFIX/Screen ]; then
  cp -fau /etc/kde3/debian/d-screen.desktop $PREFIX/Screen/.directory
  ln -sf $PREFIX/Screen $NEWPREFIX/System/Debian-Screen
fi

rm -f $NEWPREFIX/Utilities/Debian-XShells
if [ -e $PREFIX/XShells ]; then
  cp -fau /etc/kde3/debian/d-xshells.desktop $PREFIX/XShells/.directory
  ln -sf $PREFIX/XShells $NEWPREFIX/Utilities/Debian-XShells
fi

rm -f $NEWPREFIX/System/Debian-WM
if [ -e $PREFIX/WindowManagers ]; then
  cp -fau /etc/kde3/debian/d-window-managers.desktop $PREFIX/WindowManagers/.directory
  ln -sf $PREFIX/WindowManagers $NEWPREFIX/System/Debian-WM
fi

# Copy .desktop files for the Apps/* subdirectories
if [ -e $PREFIX/Apps/Databases ]; then
  cp -fau /etc/kde3/debian/d-databases.desktop $PREFIX/Apps/Databases/.directory
fi
if [ -e $PREFIX/Apps/Editors ]; then
  mkdir -p $PREFIX/Editors $NEWPREFIX/Editors/
  mv -f $PREFIX/Apps/Editors/* $PREFIX/Editors/
  rm -rf $PREFIX/Apps/Editors
  cp -faus $PREFIX/Editors/* $NEWPREFIX/Editors/
fi
if [ -e $PREFIX/Apps/Educational ]; then
  mkdir -p $PREFIX/Edutainment $NEWPREFIX/Edutainment/
  mv -f $PREFIX/Apps/Educational/* $PREFIX/Edutainment/
  rm -rf $PREFIX/Apps/Educational
  cp -faus $PREFIX/Edutainment/* $NEWPREFIX/Edutainment/
fi
if [ -e $PREFIX/Apps/Math ]; then
  cp -fau /etc/kde3/debian/d-math.desktop $PREFIX/Apps/Math/.directory
fi
if [ -e $PREFIX/Apps/Net ]; then
  mkdir -p $PREFIX/Internet/Connect $NEWPREFIX/Internet/Connect
  mv -f $PREFIX/Apps/Net/* $PREFIX/Internet/
  rm -rf $PREFIX/Apps/Net
  # xtel is in the wrong directory for some reason
  find $PREFIX -iname xtel\* -exec mv -f {} $PREFIX/Internet/ \; 2>/dev/null
  cp -faus $PREFIX/Internet/* $NEWPREFIX/Internet/
  mv -f $NEWPREFIX/Internet/{*isdn*,*ppp*,[Mm]inicom*,[Xx]tel*} $NEWPREFIX/Internet/Connect/
fi
if [ -e $PREFIX/Apps/Programming ]; then
  mkdir -p $PREFIX/Development $NEWPREFIX/Development/
  mv -f $PREFIX/Apps/Programming/{.??*,*} $PREFIX/Development/ 2>/dev/null
  rm -rf $PREFIX/Apps/Programming
  cp -faus $PREFIX/Development/{.??*,*} $NEWPREFIX/Development/ 2>/dev/null
fi
if [ -e $PREFIX/Apps/Shells ]; then
  cp -fau /etc/kde3/debian/d-shells.desktop $PREFIX/Apps/Shells/.directory
fi

# Move Sound, Graphics & Video -> Multimedia menu
if [ -e $PREFIX/Apps/Graphics ]; then
#  cp -fau /etc/kde3/debian/d-debian.desktop $PREFIX/Apps/Graphics/.directory
  mkdir -p $PREFIX/Multimedia/Graphics $NEWPREFIX/Multimedia/Graphics
  mv -f $PREFIX/Apps/Graphics/{.??*,*} $PREFIX/Multimedia/Graphics/ 2>/dev/null
  rm -rf $PREFIX/Apps/Graphics
  # qcad is in the wrong directory for some reason
  find $PREFIX -iname qcad\* -exec mv -f {} $PREFIX/Multimedia/Graphics/ \; 2>/dev/null
  cp -faus $PREFIX/Multimedia/Graphics/{.??*,*} $NEWPREFIX/Multimedia/Graphics/ 2>/dev/null
  [ -e $PREFIX/Graphics ] && { mv -f $PREFIX/Graphics/{.??*,*} $PREFIX/Multimedia/Graphics/; rm -rf $PREFIX/Graphics; }
  [ -e $NEWPREFIX/Graphics ] && { mv -f $NEWPREFIX/Graphics/{.??*,*} $NEWPREFIX/Multimedia/Graphics/; rm -rf $NEWPREFIX/Graphics; }
fi
if [ -e $PREFIX/Apps/Sound ]; then
#  cp -f /etc/kde3/debian/d-debian.desktop $PREFIX/Apps/Sound/.directory
  mkdir -p $PREFIX/Multimedia/Sound $NEWPREFIX/Multimedia/Sound
  mv -f $PREFIX/Apps/Sound/{.??*,*} $PREFIX/Multimedia/Sound/ 2>/dev/null
  cp -faus $PREFIX/Multimedia/Sound/{.??*,*} $NEWPREFIX/Multimedia/Sound/ 2>/dev/null
  [ -e $PREFIX/Sound ] && { mv -f $PREFIX/Sound/{.??*,*} $PREFIX/Multimedia/Sound/; rm -rf $PREFIX/Sound; }
  [ -e $NEWPREFIX/Sound ] && { mv -f $NEWPREFIX/Sound/{.??*,*} $NEWPREFIX/Multimedia/Sound/; rm -rf $NEWPREFIX/Sound; }
  mv -f $NEWPREFIX/Multimedia/{kmidi*,kmix*,krecord*,kscd*} $NEWPREFIX/Multimedia/Sound 2>/dev/null
fi
if [ -e $PREFIX/Apps/Viewers ]; then
  cp -fau /etc/kde3/debian/d-viewers.desktop $PREFIX/Apps/Viewers/.directory
  mkdir -p $PREFIX/Multimedia/Viewers $NEWPREFIX/Multimedia/Viewers
  mkdir -p $PREFIX/Multimedia/Video $NEWPREFIX/Multimedia/Video
  mv -f $PREFIX/Apps/Viewers/{.??*,*} $PREFIX/Multimedia/Viewers/
  mv -f $PREFIX/Multimedia/Viewers/{[Xx]ine*,[Oo]gle*,[Mm]player*,[Xx]awtv*,*[Vv]ideo[Ll][Aa][Nn]*} $PREFIX/Multimedia/Video/ 2>/dev/null
  cp -faus $PREFIX/Multimedia/Viewers/{.??*,*} $NEWPREFIX/Multimedia/Viewers/ 2>/dev/null
  cp -faus $PREFIX/Multimedia/Video/{.??*,*} $NEWPREFIX/Multimedia/Video/ 2>/dev/null
fi

if [ -e $PREFIX/Apps/System ]; then
mkdir -p $PREFIX/System $NEWPREFIX/System/
mv -f $PREFIX/Apps/System/{.??*,*} $PREFIX/System/ 2>/dev/null
rm -rf $PREFIX/Apps/System
cp -faus $PREFIX/System/{.??*,*} $NEWPREFIX/System/ 2>/dev/null
fi

if [ -e $PREFIX/Apps/Text ]; then
  cp -fau /etc/kde3/debian/d-text.desktop $PREFIX/Apps/Text/.directory
fi
#if [ -e $PREFIX/Apps/Tools ]; then
#  cp /etc/kde3/debian/d-debian.desktop $PREFIX/Apps/Tools/.directory
#fi
if [ -e $PREFIX/Apps/Emulators ]; then
  cp -fau /etc/kde3/debian/d-emulators.desktop $PREFIX/Apps/Emulators/.directory
fi
if [ -e $PREFIX/Apps/Hamradio ]; then
  cp -fau /etc/kde3/debian/d-hamradio.desktop $PREFIX/Apps/Hamradio/.directory
fi
if [ -e $PREFIX/Apps/Technical ]; then
  cp -fau /etc/kde3/debian/d-technical.desktop $PREFIX/Apps/Technical/.directory
fi

# Now, link-copy the entire Apps directory
if [ -e $PREFIX/Apps ]; then
#  cp -fau /etc/kde3/debian/d-debian.desktop $PREFIX/Apps/.directory
  cp -faus $PREFIX/Apps/* $NEWPREFIX/Applications/
fi

### Screen submenus ###

if [ -e $PREFIX/Screen/Lock ]; then
  cp -fau /etc/kde3/debian/d-lock.desktop $PREFIX/Screen/Lock/.directory
fi
if [ -e $PREFIX/Screen/Save ]; then
  cp -fau /etc/kde3/debian/d-save.desktop $PREFIX/Screen/Save/.directory
fi
if [ -e $PREFIX/Screen/Root-window ]; then
  cp -fau /etc/kde3/debian/d-root-window.desktop $PREFIX/Screen/Root-window/.directory
fi

### WindowManagers submenus ###

if [ -e $PREFIX/WindowManagers/Modules ]; then
  cp -fau /etc/kde3/debian/d-modules.desktop $PREFIX/WindowManagers/Modules/.directory
fi

### Games submenus ###

if [ -e $PREFIX/Games/Adventure ]; then
  cp -fau /etc/kde3/debian/d-adventure.desktop $PREFIX/Games/Adventure/.directory
fi
if [ -e $PREFIX/Games/Arcade ]; then
  cp -fau /etc/kde3/debian/d-arcade.desktop $PREFIX/Games/Arcade/.directory
fi
if [ -e $PREFIX/Games/Board ]; then
  cp -fau /etc/kde3/debian/d-board.desktop $PREFIX/Games/Board/.directory
fi
if [ -e $PREFIX/Games/Card ]; then
  cp -fau /etc/kde3/debian/d-card.desktop $PREFIX/Games/Card/.directory
fi
if [ -e $PREFIX/Games/Puzzles ]; then
  cp -fau /etc/kde3/debian/d-puzzles.desktop $PREFIX/Games/Puzzles/.directory
fi
if [ -e $PREFIX/Games/Sports ]; then
  cp -fau /etc/kde3/debian/d-sports.desktop $PREFIX/Games/Sports/.directory
fi
if [ -e $PREFIX/Games/Strategy ]; then
  cp -fau /etc/kde3/debian/d-strategy.desktop $PREFIX/Games/Strategy/.directory
fi
if [ -e $PREFIX/Games/Tetris-like ]; then
  cp -fau /etc/kde3/debian/d-tetris-like.desktop $PREFIX/Games/Tetris-like/.directory
fi
if [ -e $PREFIX/Games/Toys ]; then
  cp -fau /etc/kde3/debian/d-toys.desktop $PREFIX/Games/Toys/.directory
fi

# Noe link-copy the entire Games menu
if [ -e $PREFIX/Games ]; then
#  cp -fau /etc/kde3/debian/d-debian.desktop $PREFIX/Games/.directory
  cp -faus $PREFIX/Games/{.??*,*} $NEWPREFIX/Games/ 2>/dev/null
fi

# KDE clean menu updates inspired by Florent Beranger <cosmicflo@tuxfamily.org>

# Move evolution icon to the right place
ln -sf /usr/share/applications/evolution*.desktop $NEWPREFIX/Internet/ 2>/dev/null

# Office stuff
mkdir -p $NEWPREFIX/Office/Fax $NEWPREFIX/Office/Pilot $NEWPREFIX/Office/Utilities $NEWPREFIX/Office/KOffice
mv -f $NEWPREFIX/OpenOffice* $NEWPREFIX/Office 2>/dev/null
mv -f $NEWPREFIX/{Apps/Net,Internet}/efax* $NEWPREFIX/Office/Fax/ 2>/dev/null
mv -f $NEWPREFIX/Utilities/*fax* $NEWPREFIX/Office/Fax/ 2>/dev/null
# kalarm and korganizer are in the wrong directories for some reason
find $NEWPREFIX \( -iname ding\* -o -iname kalarm\* -o -iname korganizer\* -o -iname kivio\* -o -iname kugar\* -o -iname kudesigner\* \) -exec mv -f {} $NEWPREFIX/Office/Utilities \; 2>/dev/null
# Collect office tools
find $NEWPREFIX -iname \*AbiWord\* -exec mv -f {} $NEWPREFIX/Office/ \; 2>/dev/null
find $NEWPREFIX -iname \*scribus\* -exec mv -f {} $NEWPREFIX/Office/ \; 2>/dev/null
find $NEWPREFIX -iname \*gnumeric\* -exec cp -f {} $NEWPREFIX/Office/ \; 2>/dev/null
find $NEWPREFIX -iname \*acrobat\* -exec cp -f {} $NEWPREFIX/Office/Utilities/ \; 2>/dev/null
find $NEWPREFIX -iname \*pilot\* -exec mv -f {} $NEWPREFIX/Office/Pilot \; 2>/dev/null
find $NEWPREFIX/Office \( -iname koshell\* -o -iname kword\* -o -iname kspread\* -o -iname kpresenter\* -o -iname karbon\* -o -iname kchart\* -o -iname kformula\* -o -iname kontour\* -o -iname kthesaurus\* \) -exec mv -f {} $NEWPREFIX/Office/KOffice/ \; 2>/dev/null
find $NEWPREFIX -iname \*kteatime\* -exec mv -f {} $NEWPREFIX/Utilities/ \; 2>/dev/null
find $NEWPREFIX -iname \*kmidi\* -exec mv -f {} $NEWPREFIX/Multimedia/Sound/ \; 2>/dev/null
#Internet clean

# Remove dangling symlinks
find "$NEWPREFIX" -type l | while read i; do [ ! -e "$i" ] && rm -f "$i"; done

rm -f "$NEWPREFIX"/wine*
rm -f "$NEWPREFIX"/Applications/Text/xdialog.desktop
rm -f "$NEWPREFIX"/Settingsmenu/printmgr.desktop

exit 0
